echo off
echo *** Make VZ.com for FUJITSU FM series ***
rem	usage: mkfm [asm switch...]
rem
rem	%ASM%	:assembler name cap (opt,t,m) ex. set asm=opt

:select
inq "[32m1[m.FM16 [32m2[m.FMR10/50 [32m3[m.FMR60/70 [32m4[m.FMR30 [32m5[m.FM-TOWNS(MS-DOS) ? " 0 1 2 3 4 5
if not errorlevel 1 goto end
if errorlevel 5 goto FMT
if errorlevel 4 goto R30
if errorlevel 3 goto R60
if errorlevel 2 goto R50
:16B
set HARD=16B
goto asm
:R50
set HARD=R50
goto asm
:R60
set HARD=R60
goto asm
:R30
set HARD=R30
goto asm
:FMT
set HARD=FMT
set %ASM%asm=/DTOWNS/d%1/d%2/d%3/d%4
goto asm1
:asm
if not "%HARD%"=="" set %ASM%asm=/dFM%HARD%/d%1/d%2/d%3/d%4
:asm1
type nul >dummy

:makevz
echo ===== Make VZ%HARD% =====
if "%ASM%"=="opt" goto optmake
if "%ASM%"=="OPT" goto optmake
if "%ASM%"=="t" goto tmake
if "%ASM%"=="T" goto tmake
make vzfm.mak
goto link

:optmake
optasm @vzfm.omk
goto link

:tmake
make -fvzfm.mak
goto link

:link
if errorlevel 1 goto error

rem	-------	Link vz -------
rem
rem	%LNK%	:linker name cap (t, ) ex. set lnk=t
rem	%TLINK%	:link option (/c,/noi) ex. set tlink=/c

if "%LNK%"=="t" goto tlink
if "%LNK%"=="T" goto tlink

:mslink
link /noi @vz.lnk,vz%HARD%,vz%HARD%;
exe2bin vz%HARD%.exe vz%HARD%.com
del vz%HARD%.exe
goto done

:tlink
tlink %TLINK% /t @vz.lnk,vz%HARD%,vz%HARD%;
if errorlevel 1 goto end

:done
if exist vz%HARD%.map del vz%HARD%.map
dir vz%HARD%.com
goto end

:error
echo 

:end
