;
;	Keyboard driver constant definition
;
ifdef	FMR
BS_KEY	    =	0Fh		; (BS) key code.
CR_KEY	    =   1Dh		; CR key code.
SPACE	    =	67h		; SPACE key code.
XFER	    =	58h		; ϊ(XFER) key code.
ROLL_UP     =   70h		; s(ROLL UP) key code.
ROLL_DOWN   =   6Eh		; Os(ROLL DOWN) key code.
INS	    =   48h		; }(INS) key code.
DEL	    =   4Bh		; 폜(DEL) key code.
UP_ARROW    =   4Dh		; UP ARROW key code.
LEFT_ARROW  =   4Fh		; LEFT ARROW key code.
RIGHT_ARROW =   51h		; RIGHT ARROW key code.
DOWN_ARROW  =   50h		; DOWN ARROW key code.
HOME	    =	4Eh		; HOME CLR key code.
;HELP	    =	3Fh		; HELP key code.
;DOT	    =	50h		; dot key code.
NFER	    =	57h		; ϊ(NFER) key code.
CANCEL	    =	72h		;  key code.
ENTER       =	73h		; s(ENTER) key code.
PF1_KEY	    =	5Dh		; PF1 key code.
PF2_KEY	    =	5Eh		; PF2 key code.
PF3_KEY	    =	5Fh		; PF3 key code.
PF4_KEY	    =	60h		; PF4 key code.
PF5_KEY	    =	61h		; PF5 key code.
PF6_KEY	    =	62h		; PF6 key code.
PF7_KEY	    =	63h		; PF7 key code.
PF8_KEY	    =	64h		; PF8 key code.
PF9_KEY	    =	65h		; PF9 key code.
PF10_KEY    =	66h		; PF10 key code.
PF11_KEY    =	69h		; PF11 key code.
PF12_KEY    =	5Bh		; PF12 key code.

else

MPIC	    =	0		; Master Programmable Interrupt Controller.
EOI	    =	20h		; End of Interrupt.

BUZ_ON	    =	6		; Buzzer ON.
BUZ_OFF	    =	7		; Buzzer OFF.
SYS_PORT    =	37h		; System port.

KBD_DAT     =	41h		; Keyboard 8251 data.
KBD_ST	    =	43h		; Keyboard 8251 status.
KBD_CMD     =	43h		; Keyboard 8251 command.

COPY_INT    =	5		; Copy key interrupt.
STOP_INT    =	6		; Stop key interrupt.

BS_KEY	    =	0Eh		; BS key code.
CR_KEY	    =   1Ch		; CR key code.
SPACE	    =	34h		; SPACE key code.
XFER	    =	35h		; XFER key code.
ROLL_UP     =   36h		; ROLL UP key code.
ROLL_DOWN   =   37h		; ROLL DOWN key code.
INS	    =   38h		; INS key code.
DEL	    =   39h		; DEL key code.
UP_ARROW    =   3Ah		; UP ARROW key code.
LEFT_ARROW  =   3Bh		; LEFT ARROW key code.
RIGHT_ARROW =   3Ch		; RIGHT ARROW key code.
DOWN_ARROW  =   3Dh		; DOWN ARROW key code.
HOME	    =	3Eh		; HOME CLR key code.
HELP	    =	3Fh		; HELP key code.
DOT	    =	50h		; dot key code.
NFER	    =	51h		; NFER key code.

STOP	    =	60h		; STOP key code.
COPY	    =	61h		; COPY key code.

F1	    =	62h		; Function 1 key code.
F10	    =	6Bh		; Function 10 key code.

SHIFT	    =	70h		; SHIFT KEY code.
CAPS	    =	71h		; CAPS KEY code.
KANA	    =	72h		;  KEY code.
GRPH	    =	73h		; GRPH KEY code.
CTRL	    =	74h		; CTRL KEY code.

SYSTEM_FLG   =	500h		; system flag.
KBUF_BGN     =	502h		; beginning of the key data buffer.
KBUF_END     =	522h		; end of the key data buffer.
KEY_TBL_ADDR =	522h		; Key data translation table address.
KBUF_RPTR    =	524h		; pointer to the queued key data.
KBUF_WPTR    =	526h		; pointer to the free data buffer.
KBUF_CNT     =	528h		; number of the queued key data.
RETRY	     =	529h		; error retry count.
KEY_FIELD    =	52Ah		; pressed key field.
SHIFT_STTS   =	53Ah		; shift keys status.
KBUF_SIZ     =	 10h		; keyboard buffer size.

endif
